/*
 * @Author: zhoux zhouxia@supervision.ltd
 * @Date: 2023-11-16 14:30:15
 * @LastEditors: donghao donghao@supervision.ltd
 * @LastEditTime: 2024-04-02 16:51:45
 * @FilePath: \general-ai-platform-web\src\components\BatchOperation\isBatchDelete.tsx
 * @Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 */
// import { useIntl } from '@ant-design/pro-components';
import { DeleteOutlined } from '@ant-design/icons';
import { FormattedMessage, useIntl } from '@umijs/max';
import { Button, Popconfirm } from 'antd';
import { proIconForTableActionStyle } from '../../../config/defaultIcon';
import { ReactComponent as Delete } from '../../../public/images/icons/delete.svg';

type IsDeleteProps = {
  // eslint-disable-next-line @typescript-eslint/ban-types
  buttonType?: 'defalut' | 'deleteIcon';
  deleteApi: () => void;
};

const IsDelete: React.FC<IsDeleteProps> = (props) => {
  const intl = useIntl();

  return (
    <Popconfirm
      key="destroy"
      placement="topLeft"
      title={intl.formatMessage({ id: 'common.tip.title', defaultMessage: '$$$' })}
      description={intl.formatMessage({
        id: 'common.modal.table.delete.content',
        defaultMessage: '$$$',
      })}
      okText={intl.formatMessage({ id: 'common.yes', defaultMessage: '$$$' })}
      cancelText={intl.formatMessage({ id: 'common.no', defaultMessage: '$$$' })}
      onConfirm={() => {
        props.deleteApi();
      }}
    >
      {props.buttonType === 'deleteIcon' ? (
        <>
          <DeleteOutlined
            style={{
              color: 'rgba(232, 13, 13, 1)',
              ...proIconForTableActionStyle,
            }}
          />
        </>
      ) : (
        <Button
          type="link"
          size="small"
          danger
          icon={
            <Delete
              style={{
                marginRight: 3,
                display: 'inline-flex',
                alignItems: 'center',
                color: 'inherit',
                fontStyle: 'normal',
                lineHeight: 0,
                textAlign: 'center',
                textTransform: 'none',
                verticalAlign: '-0.2em',
                textRendering: 'optimizeLegibility',
              }}
            />
          }
        >
          <FormattedMessage id="pages.searchTable.destroy" defaultMessage="Destroy" />
        </Button>
      )}
    </Popconfirm>
  );
};

export default IsDelete;
