import { alarmVideoAnalysis } from '@/enums/status';
import { PageContainer, ProCard, ProList } from '@ant-design/pro-components';
import { Button, DatePicker, Image, Tabs } from 'antd';
import React, { useEffect, useState } from 'react';
import { proTablePaginationOptions } from '../../../../config/defaultTable';
// import DeviceStatusCard from './components/DeviceStatusCard';
// import CreateForm from './components/CreateForm';
import {
  postUploadAlarmList,
  postUploadAlarmListIschecked,
  postUploadWarningStatistics,
} from '@/services/realTime/alarmlist';
import type { DatePickerProps } from 'antd';
import locale from 'antd/es/date-picker/locale/zh_CN';
import moment from 'moment';
import Alarm_list_bg from '../../../../public/Alarm_list_bg.png';
import { ReactComponent as AlarmSubscript } from '../../../../public/images/icons/alarmSubscript.svg';
import { ReactComponent as NoData } from '../../../../public/images/no_data.svg';
import AlarmDetails from './components/AlarmDetails';
// import dayjs from 'dayjs';
// import 'dayjs/locale/zh-cn';

/**
 * @交互说明
 * 1、列表分页展示服务器状态
 */

export type DeleteBoxProps = {
  modalOpen: boolean;
  handleModal: () => void;
  values: any;
  reload: any;
};

const OfflineAlarmList: React.FC = () => {
  /**
   * @en-US The pop-up window of the distribution update window
   * @zh-CN 更新窗口的弹窗
   * */
  const [updateModalOpen, setUpdateModalOpen] = useState<boolean>(false);

  const [currentRow, setCurrentRow] = useState<Record<string, any>>({});
  /**
   * @en-US International configuration
   * @zh-CN 国际化配置
   * */
  // const access = useAccess();
  // const intl = useIntl();
  //  动态设置每页数量
  const [currentPageSize, setCurrentPageSize] = useState<number>(10);
  const [currentPage, setCurrentPage] = useState<number>(1);
  const [total, setTotal] = useState<number>(0);

  const [dataTestList, setdataTestList] = useState<any>([]);

  const [tab, setTab] = useState<string>(alarmVideoAnalysis[0].key);
  const [tabs, setTabs] = useState<any>([]);

  const [importDate, setImportDate] = useState<any>(null);
  const [innerDate, setInnerDate] = useState<any>(null);

  const changeProjectTab = (key: string) => {
    setTab(key);
    console.log(key);
    setCurrentPage(1);
    setCurrentPageSize(10);
    // eslint-disable-next-line @typescript-eslint/no-use-before-define
    initList(key);
  };
  const getTabs = () => {
    // if (alarmVideoAnalysis.length) {
    //   setTab(alarmVideoAnalysis[0].key);
    // }
    setTabs(alarmVideoAnalysis);
  };
  const [tabFlag, settabFlag] = useState<any>([]);
  const pollServer = () => {
    postUploadWarningStatistics({})
      .then((res) => {
        if (res && res.data.total_results) {
          // 使用 state.totalResults 来设置 selectOptions
          const newOptions = res.data.total_results[0].warning_type;
          settabFlag(newOptions);
        }
        setTimeout(pollServer, 50000);
      })
      .catch(() => {});
  };
  useEffect(() => {
    getTabs();
  }, []);
  useEffect(() => {
    pollServer();
  }, []);
  const handleUpdateModal = () => {
    if (updateModalOpen) {
      setUpdateModalOpen(false);
      setCurrentRow(undefined);
    } else {
      setUpdateModalOpen(true);
    }
  };

  // 处理初始值
  function initDataTestList(dataList: Record<string, any>[], tabId: string) {
    console.log(dataList, 'initDataTestList');
    let finalList: { content: React.JSX.Element }[] = [];
    if (Array.isArray(dataList) && dataList.length) {
      finalList = dataList.map((record) => {
        return {
          content: (
            <ProCard
              className="gn"
              style={{ backgroundColor: '#F7FBFF', margin: 0, padding: 0, borderRadius: 4 }}
              bodyStyle={{ margin: 0, padding: 0 }}
            >
              <div
                style={{
                  display: 'flex',
                  alignItems: 'center',
                  flexDirection: 'column',
                  // padding: 20,
                  paddingTop: 16,
                  justifyContent: 'center',
                  background: `url(${Alarm_list_bg})`,
                  backgroundRepeat: 'no-repeat',
                  backgroundSize: 'cover',
                  backgroundPosition: 'center',
                  height: 234,
                }}
                onClick={() => {
                  console.log('11111111111111111');
                  // eslint-disable-next-line @typescript-eslint/no-use-before-define
                  initListRead(tabId, record.id, 1);
                  setUpdateModalOpen(true);
                  setCurrentRow(record);
                }}
              >
                {/* <Image
                  width={140}
                  height={140}
                  style={{
                    borderRadius: 4,
                  }}
                  preview={false}
                  src={record.picture_path[0]}
                /> */}
                <div style={{ position: 'relative' }}>
                  <Image
                    width={140}
                    height={140}
                    style={{
                      borderRadius: 4,
                    }}
                    preview={false}
                    src={record.picture_path[0]}
                  />
                  {record.person_number > 1 && (
                    <span
                      style={{
                        display: 'inline-block',
                        position: 'absolute',
                        top: '0px',
                        right: '0px',
                        width: '64px',
                        height: '28px',
                        background: 'rgba(0,0,0,0.6)',
                        borderRadius: '0px 4px 0px 4px',
                        color: '#FAAD14',
                        fontWeight: 'bold',
                        textAlign: 'center',
                        fontSize: 12,
                        lineHeight: '28px',
                      }}
                    >
                      {record.person_number}人
                    </span>
                  )}
                </div>
                <div
                  style={{
                    paddingTop: 12,
                    height: 110,
                    display: 'flex',
                    width: '100%',
                    flexDirection: 'column',
                    justifyContent: 'space-between',
                    alignItems: 'center',
                    color: '#666',
                  }}
                >
                  <div
                    style={{
                      width: '100%',
                      padding: '0 16px',
                      whiteSpace: 'nowrap',
                      overflow: 'hidden',
                      textOverflow: 'ellipsis',
                      textAlign: 'center',
                    }}
                  >
                    {/* 来源视频:{' '} */}
                    <span
                      style={{
                        color: '#000',
                      }}
                    >
                      {record.origin}
                    </span>
                  </div>
                  <div
                    style={{
                      width: '100%',
                      height: 32,
                      background: '#BCD2F8',
                      textAlign: 'center',
                      lineHeight: '32px',
                      color: '#004FB2',
                    }}
                  >
                    {/* <span>{formatTimeByDateType(record.trigger_time)}</span> */}
                    <span>{moment(record.trigger_time).format('YYYY-MM-DD HH:mm:ss')}</span>
                  </div>
                </div>
                {record.is_checked === 0 && (
                  <span
                    style={{
                      display: 'inline-block',
                      position: 'absolute',
                      top: '0px',
                      right: '0px',
                      width: '16px',
                      height: '16px',
                      // background: '#E80D0D',
                      // borderRadius: '50%',
                    }}
                  >
                    <AlarmSubscript />
                  </span>
                )}
              </div>
            </ProCard>
          ),
        };
      });
    }

    setdataTestList(() => [...finalList]);
  }

  // 初始化加载
  async function initList(tabId: string = tab, date: any = null) {
    const reqParams = {
      page: currentPage,
      pageSize: currentPageSize,
      // desc: false,
      warning_type: tabId,
      analyse_time: date,
      // ...rest,
    };
    const resp = await postUploadAlarmList({ ...reqParams });
    // console.log(resp,'resp');
    // setCurrentPageSize(resp?.data?.count)
    setTotal(resp?.data?.count);
    initDataTestList(resp?.data?.results, tabId);
  }
  // 初始化加载已读
  async function initListRead(tabId: string = tab, id: any, is_checked: any) {
    const reqParams = {
      page: currentPage,
      pageSize: currentPageSize,
      // desc: false,
      warning_type: tabId,
      id: id,
      is_checked: is_checked,
      // ...rest,
    };
    await postUploadAlarmListIschecked({ ...reqParams }).then(() => {
      initList(tabId);
    });
    // console.log(resp,'resp');
    // setCurrentPageSize(resp?.data?.count)
  }

  const onChange: DatePickerProps['onChange'] = (date, dateString) => {
    console.log(dateString);
    setImportDate(date);
    setInnerDate(dateString);
    console.log(importDate, 'importDate');
  };
  // useEffect(() => {
  //   getTabs();
  // }, []);
  useEffect(() => {
    // 模拟异步请求数据
    initList();
  }, [currentPage, currentPageSize]);
  return (
    <PageContainer
      title={false}
      content={
        <div
          style={{
            display: 'flex',
            justifyContent: 'space-between',
          }}
        >
          <div
            style={{
              fontWeight: 600,
              fontSize: 20,
              color: '#333',
            }}
          >
            离线告警列表
          </div>

          {/* <Upload name="logo" action="/api/upload_warning_info/" showUploadList={false} onChange={handleChange}>
            <Button type="primary"
              onClick={() => {
                  // setCreateModalOpen(true);
              }}
            >
              {loading ? <LoadingOutlined /> : null}
              导入视频
            </Button>
          </Upload> */}
        </div>
      }
    >
      <ProCard
        className="gn"
        bodyStyle={{ padding: 0, margin: 0 }}
        style={{ padding: 0, margin: 0, background: 'none' }}
      >
        {/* <Tabs
          activeKey={tab}
          items={tabs}
          onChange={(key) => {
            changeProjectTab(key);
          }}
        ></Tabs> */}
        <div style={{ paddingInline: 16, height: 46, background: '#FFF', borderRadius: 4 }}>
          <Tabs
            activeKey={tab}
            items={tabs.map((item: any, index: any) => {
              const tabLabel = (
                <div className="tab-label">
                  {item.label}
                  {tabFlag?.[index] && (
                    <span
                      style={{
                        display: 'inline-block',
                        position: 'absolute',
                        top: '10px',
                        right: '5px',
                        width: '8px',
                        height: '8px',
                        background: '#E54D1F',
                        borderRadius: '50%',
                      }}
                    />
                  )}
                </div>
              );
              return {
                label: tabLabel,
                key: item.key,
              };
            })}
            onChange={(key) => {
              changeProjectTab(key);
            }}
          ></Tabs>
        </div>
        {/* <div>
          <Button
            style={{ height: 32, borderRadius: 20 }}
            type={tab === '1' ? 'primary' : 'default'}
            onClick={() => {
              changeProjectTab('1');
            }}
          >
            单人徘徊告警
            {tabFlag[0] && (
              <span
                style={{
                  display: 'inline-block',
                  position: 'absolute',
                  top: '-5px',
                  right: '5px',
                  width: '10px',
                  height: '10px',
                  background: '#E80D0D',
                  borderRadius: '50%',
                }}
              />
            )}
          </Button>
          <Button
            style={{ height: 32, borderRadius: 20, margin: '0 16px' }}
            type={tab === '2' ? 'primary' : 'default'}
            onClick={() => {
              changeProjectTab('2');
            }}
          >
            多人徘徊告警
            {tabFlag[1] && (
              <span
                style={{
                  display: 'inline-block',
                  position: 'absolute',
                  top: '-5px',
                  right: '5px',
                  width: '10px',
                  height: '10px',
                  background: '#E80D0D',
                  borderRadius: '50%',
                }}
              />
            )}
          </Button>
          <Button
            style={{ height: 32, borderRadius: 20 }}
            type={tab === '3' ? 'primary' : 'default'}
            onClick={() => {
              changeProjectTab('3');
            }}
          >
            敏感时间段告警
            {tabFlag[2] && (
              <span
                style={{
                  display: 'inline-block',
                  position: 'absolute',
                  top: '-5px',
                  right: '5px',
                  width: '10px',
                  height: '10px',
                  background: '#E80D0D',
                  borderRadius: '50%',
                }}
              />
            )}
          </Button>
        </div> */}
        <div style={{ padding: '16px 0' }}>
          选择导入时间：
          <DatePicker
            style={{ width: 280, borderRadius: 4 }}
            locale={locale}
            value={importDate}
            onChange={onChange}
            allowClear
          />
          <Button
            type="primary"
            style={{ margin: '0 16px' }}
            onClick={() => {
              // setCreateModalOpen(true);
              setImportDate(null);
              initList(tab, null);
            }}
          >
            重置
          </Button>
          <Button
            // type="primary"
            onClick={() => {
              // setCreateModalOpen(true);
              initList(tab, innerDate);
            }}
          >
            确定
          </Button>
        </div>
        <ProList<any>
          className="gn"
          ghost={true}
          style={{ height: 'calc(100vh - 240px)', overflowY: 'scroll', overflowX: 'hidden' }}
          itemCardProps={{
            ghost: true,
            bodyStyle: { padding: 0, margin: 0 },
            style: {
              width: '100%',
              border: 0,
              // minHeight: 700
              // padding: 0, margin: 0
              boxShadow: '0px 4px 8px 0px rgba(0,79,178,0.15)',
            },
          }}
          // search={{
          //   labelWidth: proTableCommonOptions.searchLabelWidth,
          // }}
          // headerTitle={
          //   <>
          //     <div>
          //       {Object.keys(tabOptions).map((item, index) => {
          //         // eslint-disable-next-line react/jsx-key
          //         return (
          //           <Button
          //             style={{ marginRight: 12,border: 'none' }}
          //             // type={activeTabIndex === index ? 'primary' : 'default'}
          //             key={index}
          //             onClick={() => {
          //               setActiveTabIndex(index);
          //             }}
          //           >
          //             {Object.keys(alarmVideoAnalysis).includes(item)
          //               ? alarmVideoAnalysis[item].miniName
          //               : ''}
          //           {"("+tabOptions[item]+ ')'}
          //           </Button>
          //         );
          //       })}
          //     </div>
          //   </>
          // }
          cardProps={{
            bodyStyle: {
              padding: '0',
              borderRadius: 8,
            },
          }}
          pagination={{
            ...proTablePaginationOptions,
            total: total,
            current: currentPage,
            pageSize: currentPageSize,
            showSizeChanger: true,
            onChange: (page, pageSize) => {
              console.log(page, pageSize);
              setCurrentPage(page);
              setCurrentPageSize(pageSize);
            },
          }}
          locale={{
            emptyText: (
              <div
                style={{
                  paddingBlockStart: 20,
                }}
              >
                <NoData />
              </div>
            ),
          }}
          showActions="hover"
          rowSelection={false}
          grid={{ gutter: 16, xs: 1, md: 2, lg: 2, xl: 5, xxl: 6 }}
          metas={{
            type: {
              // 不展示在筛选项
              hideInSearch: true,
            },
            content: {
              hideInSearch: true,
            },
            actions: {
              cardActionProps: 'extra',
            },
          }}
          dataSource={dataTestList}
        />
      </ProCard>

      <AlarmDetails
        updateModalOpen={updateModalOpen}
        values={currentRow || {}}
        handleModal={handleUpdateModal}
        reload={initList}
        warning_type={tab}
      />
    </PageContainer>
  );
};

export default OfflineAlarmList;
