import { getAlarmRules } from '@/services/realTime/alarmRules';
import { EditOutlined } from '@ant-design/icons';
import { PageContainer, ProCard, ProList } from '@ant-design/pro-components';
import { FormattedMessage } from '@umijs/max';
import { Button, Tag } from 'antd';
import moment from 'moment';
import React, { useEffect, useState } from 'react';
import { proTablePaginationOptions } from '../../../../config/defaultTable';
import Alarm_rule from '../../../../public/images/alarm_rule.svg';
import UpdateForm from './components/UpdateForm';
import UpdateMultiForm from './components/UpdateMultiForm';
import UpdateTimeForm from './components/UpdateTimeForm';
const AlarmRules: React.FC = () => {
  /**
   * @en-US International configuration
   * @zh-CN 国际化配置
   * */
  // const actionRef = useRef<ActionType>();
  //  动态设置每页数量
  const [currentPageSize, setCurrentPageSize] = useState<number>(10);
  const [currentPage, setCurrentPage] = useState<number>(1);
  const [total, setTotal] = useState<number>(0);
  const [dataTestList, setdataTestList] = useState<any>([]);
  // const handleDestroy = async (selectedRow: API.DeviceCategory) => {
  //   // deleteDeviceCategoryDeleteDeviceCategory({ id: selectedRow.id })
  //   //   .then(() => {
  //   //     message.success(intl.formatMessage({ id: 'common.success', defaultMessage: '成功' }));
  //   //     actionRef.current?.reload();
  //   //   })
  //   //   .catch(() => {
  //   //     message.error(intl.formatMessage({ id: 'common.failure', defaultMessage: '失败' }));
  //   //   });
  // };

  const [currentRow, setCurrentRow] = useState<API.DeviceCategory>();
  // 编辑弹框
  const [updateModalOpen, setUpdateModalOpen] = useState<boolean>(false);
  const [updateMultiModalOpen, setUpdateMultiModalOpen] = useState<boolean>(false);
  const [updateTimeModalOpen, setUpdateTimeModalOpen] = useState<boolean>(false);

  const handleUpdateModal = () => {
    if (updateModalOpen) {
      setUpdateModalOpen(false);
      setCurrentRow(undefined);
    } else {
      setUpdateModalOpen(true);
    }
  };
  const handleUpdateMultiModal = () => {
    if (updateMultiModalOpen) {
      setUpdateMultiModalOpen(false);
      setCurrentRow(undefined);
    } else {
      setUpdateMultiModalOpen(true);
    }
  };
  const handleUpdateTimeModal = () => {
    setCurrentRow(undefined);

    if (updateTimeModalOpen) {
      setUpdateTimeModalOpen(false);
    } else {
      setUpdateTimeModalOpen(true);
    }
  };
  // 处理初始值
  function initDataTestList(dataList: Record<string, any>[]) {
    console.log(dataList, 'initDataTestList');
    let finalList: { content: React.JSX.Element }[] = [];
    if (Array.isArray(dataList) && dataList.length) {
      finalList = dataList.map((record) => {
        return {
          content: (
            <ProCard
              className="gn"
              style={{ backgroundColor: '#F7FBFF', margin: 0, padding: 0, borderRadius: 8 }}
              bodyStyle={{ margin: 0, padding: 0 }}
            >
              <div
                style={{
                  boxSizing: 'border-box',
                  height: 172,
                }}
                // key={index}
              >
                <div
                  style={{
                    boxSizing: 'border-box',
                    paddingInline: 12,
                    height: 50,
                    background: '#FFF',
                    display: 'flex',
                    alignItems: 'center',
                    justifyContent: 'space-between',
                    borderBottom: '1px solid #E0E0E0',
                  }}
                >
                  <div
                    style={{
                      fontWeight: 'bold',
                      fontSize: 14,
                    }}
                  >
                    {record.warning_name}
                  </div>
                  <Button
                    key="update"
                    type="link"
                    size="small"
                    style={{
                      color: '#004FB2',
                    }}
                    icon={
                      <EditOutlined
                        style={{
                          marginRight: 8,
                        }}
                      />
                    }
                    onClick={() => {
                      console.log(record);
                      if (record.id === 1) {
                        setUpdateModalOpen(true);
                      } else if (record.id === 2) {
                        setUpdateMultiModalOpen(true);
                      } else {
                        setUpdateTimeModalOpen(true);
                      }
                      setCurrentRow(record);
                    }}
                  >
                    <FormattedMessage id="common.edit" defaultMessage="编辑" />
                  </Button>
                </div>
                <div
                  style={{
                    boxSizing: 'border-box',
                    padding: '7px 12px',
                    display: 'flex',
                    justifyContent: 'space-between',
                  }}
                >
                  <div
                    style={{
                      display: 'flex',
                      flexDirection: 'column',
                      justifyContent: 'space-around',
                    }}
                  >
                    <div>
                      规则ID: <span>{record.id}</span>
                    </div>
                    <div>
                      创建时间:{' '}
                      <span>{moment(record.update_time).format('YYYY-MM-DD hh:mm:ss')}</span>
                    </div>
                    <div>
                      规则状态:{' '}
                      <Tag
                        bordered={false}
                        color={record.is_use === 1 ? 'success' : ''}
                        style={{
                          fontSize: 14,
                          color: record.is_use === 1 ? '#52C41A' : '#999',
                        }}
                      >
                        {record.is_use === 1 ? '已启用' : '未启用'}
                      </Tag>
                    </div>
                  </div>
                  <div
                    style={{
                      width: 130,
                      height: 107,
                    }}
                  >
                    <img width={'100%'} height={'100%'} src={Alarm_rule} />
                  </div>
                </div>
              </div>
            </ProCard>
          ),
        };
      });
    }

    setdataTestList(() => [...finalList]);
  }

  // 初始化加载
  async function initList() {
    const reqParams = {
      page: currentPage,
      pageSize: currentPageSize,
      // desc: false,
      orderKey: '',
      // ...rest,
    };
    const resp = await getAlarmRules({ ...reqParams });
    // console.log(resp,'resp');
    // setCurrentPageSize(resp?.data?.count)
    setTotal(resp?.data?.count);
    initDataTestList(resp?.data?.results);
  }
  useEffect(() => {
    // 模拟异步请求数据
    initList();
  }, [currentPage, currentPageSize]);
  return (
    <PageContainer
      title={false}
      content={
        <div
          style={{
            display: 'flex',
            justifyContent: 'space-between',
          }}
        >
          <div
            style={{
              fontWeight: 600,
              fontSize: 20,
              color: '#333',
            }}
          >
            实时告警规则
          </div>
        </div>
      }
    >
      <ProList<any>
        className="gn"
        ghost={true}
        itemCardProps={{
          ghost: true,
          bodyStyle: { padding: 0, margin: 0 },
          style: {
            width: '100%',
            border: 0,
            // minHeight: 700
            // padding: 0, margin: 0
            boxShadow: '0px 4px 8px 0px rgba(0,79,178,0.15)',
          },
        }}
        cardProps={{
          bodyStyle: {
            padding: '0',
            borderRadius: 8,
          },
        }}
        pagination={{
          ...proTablePaginationOptions,
          total: total,
          current: currentPage,
          pageSize: currentPageSize,
          showSizeChanger: true,
          onChange: (page, pageSize) => {
            console.log(page, pageSize);
            setCurrentPage(page);
            setCurrentPageSize(pageSize);
          },
        }}
        showActions="hover"
        rowSelection={false}
        grid={{ gutter: 16, xs: 1, md: 2, lg: 2, xl: 3, xxl: 4 }}
        metas={{
          type: {
            // 不展示在筛选项
            hideInSearch: true,
          },
          content: {
            hideInSearch: true,
          },
          actions: {
            cardActionProps: 'extra',
          },
        }}
        dataSource={dataTestList}
      />
      <UpdateForm
        updateModalOpen={updateModalOpen}
        values={currentRow || {}}
        handleModal={handleUpdateModal}
        reload={initList}
      />
      <UpdateMultiForm
        updateModalOpen={updateMultiModalOpen}
        values={currentRow || {}}
        handleModal={handleUpdateMultiModal}
        reload={initList}
      />
      <UpdateTimeForm
        updateModalOpen={updateTimeModalOpen}
        values={currentRow || {}}
        handleModal={handleUpdateTimeModal}
        reload={initList}
      />
    </PageContainer>
  );
};

export default AlarmRules;
