import TableActionCard from '@/components/TableActionCard';
import { getPlatform } from '@/services/realTime/interfaces';
import type { ActionType, ProColumns } from '@ant-design/pro-components';
import { PageContainer, ProCard, ProTable } from '@ant-design/pro-components';
import { FormattedMessage } from '@umijs/max';
import { Button } from 'antd';
import React, { useRef, useState } from 'react';
import { proTablePaginationOptions } from '../../../../config/defaultTable';
import CaptureButton from './components/CaptureButton';
import CaptureForm from './components/CaptureForm';
import './components/CaptureForm.less';
import CreateForm from './components/CreateForm';
import UpdateForm from './components/UpdateForm';
// svg 转组件
// import { ReactComponent as Details } from '../../../../public/images/icons/details.svg';
// import { ReactComponent as Delete } from '../../../../public/images/icons/delete.svg';
import { EditOutlined } from '@ant-design/icons';
import { ReactComponent as Capture } from '../../../../public/images/icons/capture.svg';
const DeviceList: React.FC = () => {
  /**
   * @en-US International configuration
   * @zh-CN 国际化配置
   * */
  // const intl = useIntl();
  const actionRef = useRef<ActionType>();
  //  动态设置每页数量
  const [currentPageSize, setCurrentPageSize] = useState<number>(10);

  // const handleDestroy = async (selectedRow: API.UpdateInterfacesParams) => {
  //   postInterfaces({ id: selectedRow.id, device_status: '3' })
  //     .then(() => {
  //       message.success(intl.formatMessage({ id: 'common.success', defaultMessage: '成功' }));
  //       actionRef.current?.reload();
  //     })
  //     .catch(() => {
  //       message.error(intl.formatMessage({ id: 'common.failure', defaultMessage: '失败' }));
  //     });
  // };

  const [currentRow, setCurrentRow] = useState<API.UpdateInterfacesParams>();
  /**
   * @en-US Pop-up window of new window
   * @zh-CN 新建窗口的弹窗
   *  */
  const [createModalOpen, setCreateModalOpen] = useState<boolean>(false);
  const handleCreateModal = () => {
    if (createModalOpen) {
      setCreateModalOpen(false);
      setCurrentRow(undefined);
    } else {
      setCreateModalOpen(true);
    }
  };
  // 编辑弹框
  const [updateModalOpen, setUpdateModalOpen] = useState<boolean>(false);

  const handleUpdateModal = () => {
    if (updateModalOpen) {
      setUpdateModalOpen(false);
      setCurrentRow(undefined);
    } else {
      setUpdateModalOpen(true);
    }
  };

  // 最近拍摄
  const [captureModalOpen, setCaptureModalOpen] = useState<boolean>(false);

  const handleCaptureModal = () => {
    console.log(captureModalOpen);
    if (captureModalOpen) {
      setCaptureModalOpen(false);
      setCurrentRow(undefined);
    } else {
      setCaptureModalOpen(true);
    }
  };
  const expandedRowRender = (record: any) => {
    console.log(record, 'record');
    const data = record.devices;
    return (
      <ProTable
        className="table_body_bg"
        cardProps={{
          bodyStyle: {
            margin: 0,
            padding: 0,
          },
        }}
        rowKey={(record) => record.id}
        columns={[
          {
            title: (
              <FormattedMessage
                id="device.interface_manage.table.list.name"
                defaultMessage="接口名称"
              />
            ),
            dataIndex: 'device_name',
            hideInSearch: true,
            width: 240,
            // width: 240,
          },
          {
            title: <FormattedMessage id="alarm_rules.page.status" defaultMessage="设备状态" />,
            dataIndex: 'test_result',
            hideInSearch: true,
            // width: 280,
            render: (dom, entity) => {
              return <CaptureButton values={entity || {}} reload={actionRef.current?.reload} />;
            },
          },
          {
            title: (
              <FormattedMessage
                id="device.interface_manage.table.list.createTime"
                defaultMessage="创建时间"
              />
            ),
            // width: 200,
            dataIndex: 'create_time',
            sorter: true,
            hideInSearch: true,
            valueType: 'dateTime',
          },

          {
            title: <FormattedMessage id="pages.searchTable.titleOption" defaultMessage="操作" />,
            dataIndex: 'option',
            valueType: 'option',
            // width: 100,
            fixed: 'right',
            render: (_, record) => [
              <TableActionCard
                key="TableActionCardRef"
                renderActions={[
                  {
                    key: 'capture',
                    renderDom: (
                      <Button
                        key="capture"
                        type="link"
                        size="small"
                        style={{
                          color: '#004FB2',
                        }}
                        icon={
                          <Capture
                            style={{
                              marginRight: 3,
                              display: 'inline-flex',
                              alignItems: 'center',
                              color: 'inherit',
                              fontStyle: 'normal',
                              lineHeight: 0,
                              textAlign: 'center',
                              textTransform: 'none',
                              verticalAlign: '-0.2em',
                              textRendering: 'optimizeLegibility',
                            }}
                          />
                        }
                        onClick={() => {
                          console.log('11');
                          setCaptureModalOpen(true);
                          setCurrentRow(record);
                        }}
                      >
                        {/* 最近拍摄 */}
                        <FormattedMessage
                          id="device.interface_manage.table.list.capture"
                          defaultMessage="最近拍摄"
                        />
                      </Button>
                    ),
                  },
                ]}
              ></TableActionCard>,
            ],
          },
        ]}
        headerTitle={false}
        search={false}
        options={false}
        dataSource={data}
        pagination={false}
        showHeader={false}
      />
    );
  };
  const columns: ProColumns<API.UpdateInterfacesParams>[] = [
    {
      title: (
        <FormattedMessage
          id="device.interface_manage.table.list.platform_name"
          defaultMessage="设备名称"
        />
      ),
      dataIndex: 'platform_name',
      width: 240,
      hideInSearch: true,
    },
    {
      title: (
        <FormattedMessage
          id="device.interface_manage.table.list.statusUpdate"
          defaultMessage="最近一次状态查询"
        />
      ),
      dataIndex: 'test_result',
      hideInSearch: true,
      render: (dom, entity) => {
        return <CaptureButton values={entity || {}} reload={actionRef.current?.reload} />;
      },
    },
    {
      title: (
        <FormattedMessage
          id="device.interface_manage.table.list.createTime"
          defaultMessage="创建时间"
        />
      ),
      dataIndex: 'create_time',
      sorter: true,
      hideInSearch: true,
      valueType: 'dateTime',
    },

    {
      title: <FormattedMessage id="pages.searchTable.titleOption" defaultMessage="操作" />,
      dataIndex: 'option',
      valueType: 'option',
      // width: '300px',
      fixed: 'right',
      render: (_, record) => [
        <TableActionCard
          key="TableActionCardRef"
          renderActions={[
            {
              key: 'capture',
              renderDom: (
                // <Button
                //   key="capture"
                //   type="link"
                //   size="small"
                //   style={{
                //     color: '#004FB2',
                //   }}
                //   icon={
                //     <Capture
                //       style={{
                //         marginRight: 3,
                //         display: 'inline-flex',
                //         alignItems: 'center',
                //         color: 'inherit',
                //         fontStyle: 'normal',
                //         lineHeight: 0,
                //         textAlign: 'center',
                //         textTransform: 'none',
                //         verticalAlign: '-0.2em',
                //         textRendering: 'optimizeLegibility',
                //       }}
                //     />
                //   }
                //   onClick={() => {
                //     console.log('11');
                //     setCaptureModalOpen(true);
                //     setCurrentRow(record);
                //   }}
                // >
                //   {/* 最近拍摄 */}
                //   <FormattedMessage
                //     id="device.interface_manage.table.list.capture"
                //     defaultMessage="最近拍摄"
                //   />
                // </Button>
                <Button
                  key="update"
                  type="link"
                  size="small"
                  style={{
                    color: '#004FB2',
                  }}
                  icon={
                    <EditOutlined
                      style={{
                        marginRight: 3,
                      }}
                    />
                  }
                  onClick={() => {
                    setUpdateModalOpen(true);
                    setCurrentRow(record);
                  }}
                >
                  <FormattedMessage
                    id="device.interface_manage.table.list.rename"
                    defaultMessage="重命名"
                  />
                </Button>
              ),
            },
          ]}
        ></TableActionCard>,
      ],
    },
  ];
  return (
    <PageContainer
      title={false}
      content={
        <div
          style={{
            display: 'flex',
            justifyContent: 'space-between',
          }}
        >
          <div
            style={{
              fontWeight: 600,
              fontSize: 20,
              color: '#333',
            }}
          >
            实时设备管理
          </div>
          {/* <Button
            type="primary"
            onClick={() => {
              setCreateModalOpen(true);
            }}
          >
            <FormattedMessage
              id="device.interface_manage.table.list.add"
              defaultMessage="新建设备/输入源"
            />
          </Button> */}
        </div>
      }
    >
      {/* <ProTable<API.DeviceCategory>
        cardProps={{
          bodyStyle: {
            padding: 20,
          },
        }}
        options={{ fullScreen: false, setting: false, density: false, reload: false }}
        actionRef={actionRef}
        rowKey="key"
        search={false}
        showSorterTooltip={false}
        pagination={{
          ...proTablePaginationOptions,
          pageSize: currentPageSize,
          onChange: (page, pageSize) => setCurrentPageSize(pageSize),
        }}
        columnsState={{
          persistenceKey: 'device_category_list',
          persistenceType: 'localStorage',
        }}
        request={async (params = {}, sort) => {
          const { current, ...rest } = params;
          const reqParams = {
            page: current,
            desc: false,
            orderKey: '',
            ...rest,
          };
          if (sort && Object.keys(sort).length) {
            reqParams.orderKey = Object.keys(sort)[0];
            let sort_select = sort[reqParams.orderKey];
            reqParams.desc = sort_select === 'descend';
          }
          let resp = await getInterfaces({ ...reqParams });
          return {
            data: resp.data.results.map((v: API.DeviceCategory) => {
              return { ...v, key: v.id };
            }),
            success: resp.success,
            total: resp.data.count,
            current: resp.data.page,
            pageSize: resp.data.pageSize,
          };
        }}
        columns={columns}
      /> */}
      <ProCard
        style={{ margin: 0, padding: 0, boxShadow: '0px 4px 8px 0px rgba(0,79,178,0.15)' }}
        bodyStyle={{ margin: 0, padding: 0 }}
        headerBordered
        title="设备状态"
        // extra={
        //   <Button
        //     type="primary"
        //     style={{
        //       boxShadow: 'none',
        //     }}
        //     onClick={() => {
        //       setCreateModalOpen(true);
        //     }}
        //   >
        //     <FormattedMessage
        //       id="device.interface_manage.table.list.add"
        //       defaultMessage="新建设备/输入源"
        //     />
        //   </Button>
        // }
      >
        <ProTable<API.DeviceCategory>
          cardProps={{
            bodyStyle: {
              padding: 20,
            },
          }}
          className="table_header_bg"
          options={{ fullScreen: false, setting: false, density: false, reload: false }}
          actionRef={actionRef}
          rowKey="key"
          search={false}
          showSorterTooltip={false}
          pagination={{
            ...proTablePaginationOptions,
            pageSize: currentPageSize,
            onChange: (page, pageSize) => setCurrentPageSize(pageSize),
          }}
          columnsState={{
            persistenceKey: 'device_category_list',
            persistenceType: 'localStorage',
          }}
          request={async (params = {}, sort) => {
            const { current, ...rest } = params;
            const reqParams = {
              page: current,
              desc: false,
              orderKey: '',
              ...rest,
            };
            if (sort && Object.keys(sort).length) {
              reqParams.orderKey = Object.keys(sort)[0];
              let sort_select = sort[reqParams.orderKey];
              reqParams.desc = sort_select === 'descend';
            }
            let resp = await getPlatform({ ...reqParams });
            return {
              data: resp.data.results.map((v: API.DeviceCategory) => {
                return { ...v, key: v.id };
              }),
              success: resp.success,
              total: resp.data.count,
              current: resp.data.page,
              pageSize: resp.data.pageSize,
            };
          }}
          columns={columns}
          expandable={{ expandedRowRender }}
        />
      </ProCard>
      <CreateForm
        createModalOpen={createModalOpen}
        values={currentRow || {}}
        handleModal={handleCreateModal}
        reload={actionRef.current?.reload}
      />
      <UpdateForm
        updateModalOpen={updateModalOpen}
        values={currentRow || {}}
        handleModal={handleUpdateModal}
        reload={actionRef.current?.reload}
      />
      <CaptureForm
        captureModalOpen={captureModalOpen}
        values={currentRow || {}}
        handleModal={handleCaptureModal}
        reload={actionRef.current?.reload}
      />
    </PageContainer>
  );
};

export default DeviceList;
