// import { alarmRulesEnums } from '@/enums/status';
import { PageContainer, ProCard, ProList } from '@ant-design/pro-components';
import { Button, Checkbox, DatePicker, Select } from 'antd';
import React, { useEffect, useState } from 'react';
import { proTablePaginationOptions } from '../../../../config/defaultTable';
// import DeviceStatusCard from './components/DeviceStatusCard';
// import CreateForm from './components/CreateForm';
import { postWarningStatistics } from '@/services/realTime/alarmlist';
import { getInvolvedList } from '@/services/realTime/involved';
import locale from 'antd/es/date-picker/locale/zh_CN';
import { CheckboxProps } from 'antd/lib/checkbox';
import { DatePickerProps } from 'antd/lib/date-picker';
import moment from 'moment';
import { ReactComponent as NoData } from '../../../../public/images/no_data.svg';
import ImageWithPopover from './components/ImageWithPopover';
import InvolvedDetails from './components/InvolvedDetails';
import './components/InvolvedDetails.less';

/**
 * @交互说明
 * 1、列表分页展示服务器状态
 */
// const tabOptions: Record<string, any> = {
//   singlePersonHoveringAlarm: 90,
//   multiplePersonGatheringAlarm: 20,
//   sensitiveTimePeriodAlarm: 20,
//   ignored: 2,
//   // processingStatus: 10,
//   // errorStatus: 20,
// };
// export type DeleteBoxProps = {
//   modalOpen: boolean;
//   handleModal: () => void;
//   values: any;
//   reload: any;
// };

const InvolvedList: React.FC = () => {
  // const [cardActionProps, setCardActionProps] = useState<'actions' | 'extra'>('extra');
  /**
   * @en-US Pop-up window of new window
   * @zh-CN 新建窗口的弹窗
   *  */
  // const [createModalOpen, setCreateModalOpen] = useState<boolean>(false);
  /**
   * @en-US The pop-up window of the distribution update window
   * @zh-CN 更新窗口的弹窗
   * */
  const [updateModalOpen, setUpdateModalOpen] = useState<boolean>(false);
  /**
   * @en-US The pop-up window of the distribution update window
   * @zh-CN 删除窗口
   * */
  // const [modalOpen, setModalOpen] = useState(false);
  const [currentRow, setCurrentRow] = useState<Record<string, any>>({});
  /**
   * @en-US International configuration
   * @zh-CN 国际化配置
   * */
  // const access = useAccess();
  // const intl = useIntl();
  // const actionRef = useRef<ActionType>();
  //  动态设置每页数量
  const [currentPageSize, setCurrentPageSize] = useState<number>(10);
  const [currentPage, setCurrentPage] = useState<number>(1);
  const [total, setTotal] = useState<number>(0);

  // const [activeTabIndex, setActiveTabIndex] = useState<number>(0);
  const [dataTestList, setdataTestList] = useState<any>([]);

  // const [tab] = useState<string>(alarmRulesEnums[0].key);
  // const [tabs, setTabs] = useState<any>([]);

  const [importDate, setImportDate] = useState<any>(null);
  const [innerDate, setInnerDate] = useState<any>(null);
  const [classify, setClassify] = useState<string>('all');

  const [selectOptions, setSelectOptions] = useState<any>([]);
  const [selectValue, setSelectValue] = useState<number>();
  const pollServer = () => {
    postWarningStatistics({})
      .then((res) => {
        if (res && res.data.total_results) {
          // 使用 state.totalResults 来设置 selectOptions
          const newOptions = res.data.total_results.map((record: any) => ({
            value: record.id,
            label: (
              <span>
                {record.platform_name}
                {record.have_warning && (
                  <span
                    style={{
                      display: 'inline-block',
                      marginLeft: 5,
                      width: '10px',
                      height: '10px',
                      background: '#E54D1F',
                      borderRadius: '50%',
                    }}
                  />
                )}
              </span>
            ),
          }));
          setSelectValue(res.data.total_results[0].id);
          setSelectOptions(newOptions);
        }
        // setTimeout(pollServer, 5000);
      })
      .catch(() => {});
  };
  useEffect(() => {
    pollServer();
    console.log(selectValue, 'selectValue');
  }, []);

  const handleUpdateModal = () => {
    if (updateModalOpen) {
      setUpdateModalOpen(false);
      setCurrentRow(undefined);
    } else {
      setUpdateModalOpen(true);
    }
  };

  // const handleDestroy = async () => {
  //   if (modalOpen) {
  //     setModalOpen(false);
  //     setCurrentRow(undefined);
  //   } else {
  //     setModalOpen(true);
  //   }
  //   // deleteBusinessImageDeleteBusinessImage({ id: selectedRow.id })
  //   //   .then(() => {
  //   //     message.success(intl.formatMessage({ id: 'common.success', defaultMessage: '$$$' }));
  //   //     actionRef.current?.reload();
  //   //   })
  //   //   .catch(() => {
  //   //     message.error(intl.formatMessage({ id: 'common.failure', defaultMessage: '$$$' }));
  //   //   });
  // };

  // const { confirm } = Modal;
  // const showConfirm = (record: any) => {
  //   confirm({
  //     title: `确定删除${record.name}吗`,
  //     icon: <QuestionCircleFilled />,
  //     content: '确定删除服务器1吗？删除后将找不到此服务器，请谨慎操作.',
  //     okText: '确认',
  //     cancelText: '取消',
  //     width: 560,
  //     onOk() {
  //       console.log('OK');
  //     },
  //     onCancel() {
  //       console.log('Cancel');
  //     },
  //   });
  // };

  // 处理初始值
  function initDataTestList(dataList: Record<string, any>[]) {
    console.log(dataList, 'initDataTestList');
    let finalList: { content: React.JSX.Element }[] = [];
    if (Array.isArray(dataList) && dataList.length) {
      finalList = dataList.map((record, index) => {
        return {
          content: (
            <ProCard
              className="gn"
              style={{ backgroundColor: '#F5F6FF', margin: 0, padding: 0, borderRadius: 4 }}
              bodyStyle={{ margin: 0, padding: 0 }}
            >
              <div
                style={{
                  display: 'flex',
                  flexDirection: 'column',
                  alignItems: 'center',
                  justifyContent: 'center',
                  paddingTop: 16,
                  height: 272,
                  background: '#FAFCFF',
                  // backgroundImage: 'url(../../../../public/images/involved/involved_jiaobiao.png)',
                }}
                onClick={() => {
                  console.log(index, 'index');
                  setUpdateModalOpen(true);
                  setCurrentRow(record);
                }}
              >
                {/* <Image
                  width={96}
                  preview={false}
                  src={record.picture_path[0]}
                /> */}
                <ImageWithPopover
                  src={record.picture_path}
                  // eslint-disable-next-line @typescript-eslint/no-use-before-define
                  reload={initList}
                  person_id={record.person_id}
                  classify={record.classify}
                  // handleInvolved={handleInvolved}
                ></ImageWithPopover>
                <div
                  style={{
                    marginTop: 16,
                    padding: '12px 16px',
                    width: '100%',
                    height: '100%',
                    display: 'flex',
                    flexDirection: 'column',
                    justifyContent: 'space-between',
                    alignItems: 'center',
                    background: '#fff',
                    color: '#999',
                    fontSize: 13,
                    boxShadow: '0px -1px 0px 0px rgba(0,79,178,0.1)',
                  }}
                >
                  <div
                    style={{
                      width: '185px',
                      whiteSpace: 'nowrap',
                      overflow: 'hidden',
                      textOverflow: 'ellipsis',
                    }}
                  >
                    首次识别:{' '}
                    <span
                      style={{
                        color: '#000',
                      }}
                    >
                      {moment(record.appear_time_first).format('YYYY-MM-DD hh:mm:ss')}
                    </span>
                  </div>
                  <div
                    style={{
                      width: '185px',
                      whiteSpace: 'nowrap',
                      overflow: 'hidden',
                      textOverflow: 'ellipsis',
                    }}
                  >
                    来源设备:{' '}
                    <span
                      style={{
                        color: '#000',
                      }}
                    >
                      {record.device_name_first}
                    </span>
                  </div>
                  <div
                    style={{
                      width: '185px',
                      whiteSpace: 'nowrap',
                      overflow: 'hidden',
                      textOverflow: 'ellipsis',
                    }}
                  >
                    最后识别:{' '}
                    <span
                      style={{
                        color: '#000',
                      }}
                    >
                      {moment(record.appear_time).format('YYYY-MM-DD hh:mm:ss')}
                    </span>
                  </div>
                  <div
                    style={{
                      width: '185px',
                      whiteSpace: 'nowrap',
                      overflow: 'hidden',
                      textOverflow: 'ellipsis',
                    }}
                  >
                    来源设备:{' '}
                    <span
                      style={{
                        color: '#000',
                      }}
                    >
                      {record.device_name}
                    </span>
                  </div>
                </div>
                {/* {record.classify === 1 && (
                  <div style={{ position: 'absolute', top: 0, right: 0 }}>
                    <img src={Involved_jiaobiao} />
                  </div>
                )} */}
              </div>
            </ProCard>
          ),
        };
      });
    }

    setdataTestList(() => [...finalList]);
  }

  // 初始化加载
  async function initList(
    tabId: string = 'all',
    date: any = null,
    selectValues: any = selectValue,
  ) {
    const reqParams = {
      page: currentPage,
      pageSize: currentPageSize,
      // desc: false,
      classify: tabId,
      analyse_time: date,
      platform_id: selectValues,
      // ...rest,
    };
    const resp = await getInvolvedList({ ...reqParams });
    // console.log(resp,'resp');
    // setCurrentPageSize(resp?.data?.count)
    setTotal(resp?.data?.count);
    initDataTestList(resp?.data?.results);
    // request={async (params = {}, sort) => {
    //   const { current, ...rest } = params;
    //   const reqParams = {
    //     page: current,
    //     desc: false,
    //     warning_type: tab,
    //     ...rest,
    //   };
    //   if (sort && Object.keys(sort).length) {
    //     reqParams.orderKey = Object.keys(sort)[0];
    //     let sort_select = sort[reqParams.orderKey];
    //     reqParams.desc = sort_select === 'descend';
    //   }
    //   // TODO 联调查询设备状态接口
    //   console.log(reqParams, 'reqParams');
    //   let resp = await postAlarmList({ ...reqParams });
    //   console.log(resp, 'postAlarmList_result');

    //   initDataTestList(resp.result);
    //   // return {
    //   //   data: resp.result,
    //   //   success: resp.success,
    //   //   total: resp.count,
    //   //   current: resp.count,
    //   //   pageSize: resp.count,
    //   // };
    // }}
  }
  const onChange: DatePickerProps['onChange'] = (date, dateString) => {
    console.log(dateString);
    setImportDate(date);
    setInnerDate(dateString);
    console.log(importDate, 'importDate');
  };
  const onChangeCheckbox: CheckboxProps['onChange'] = (e) => {
    console.log(`checked = ${e.target.checked}`);
    if (e.target.checked) {
      setClassify('1');
      initList('1', innerDate);
    } else {
      setClassify('all');
      initList('all', innerDate);
    }
  };
  const handleChange = (value: any) => {
    console.log(`selected ${value}`);
    setSelectValue(value);
  };
  // useEffect(() => {
  //   // getTabs();
  //   // initList();
  // }, []);
  useEffect(() => {
    // 模拟异步请求数据
    initList();
  }, [currentPage, currentPageSize]);
  return (
    <PageContainer
      title={false}
      content={
        <div
          style={{
            display: 'flex',
            justifyContent: 'space-between',
          }}
        >
          <div
            style={{
              fontWeight: 600,
              fontSize: 20,
              color: '#333',
            }}
          >
            实时告警汇总
          </div>
        </div>
      }
      className="PageContainerheader"
    >
      <ProCard
        className="gn"
        bodyStyle={{ padding: 0, margin: 0 }}
        style={{ padding: 0, margin: 0, background: 'none' }}
      >
        <div
          style={{
            // paddingBottom: 12,
            display: 'flex',
            justifyContent: 'space-between',
            alignItems: 'center',
          }}
        >
          <div style={{ paddingBottom: 16 }}>
            <Select
              defaultValue={1}
              className="select_Bg"
              style={{ width: 280, borderRadius: 4, marginRight: 12 }}
              onChange={handleChange}
              value={selectValue}
              options={selectOptions}
            />
            <DatePicker
              style={{ width: 280, borderRadius: 4 }}
              locale={locale}
              value={importDate}
              onChange={onChange}
              allowClear
            />
            <Button
              type="primary"
              style={{ margin: '0 12px', borderRadius: 4 }}
              onClick={() => {
                // setCreateModalOpen(true);
                initList(classify, innerDate);
              }}
            >
              查询
            </Button>
            <Button
              // type="primary"
              style={{ borderRadius: 4 }}
              onClick={() => {
                // setCreateModalOpen(true);
                setImportDate(null);
                setInnerDate(null);
                // setSelectValue(1);
                initList(classify, null);
              }}
            >
              重置
            </Button>
          </div>
          <div
            style={{
              boxSizing: 'border-box',
              display: 'flex',
              justifyContent: 'center',
              alignItems: 'center',
              width: 146,
              height: 32,
              background: 'rgba(0,79,178,0.1)',
              borderRadius: 4,
              border: '1px solid rgba(0,79,178,1)',
              // fontSize: 14
            }}
          >
            <Checkbox
              onChange={onChangeCheckbox}
              style={{
                fontSize: 14,
                color: '#004FB2',
              }}
            >
              仅显示重点关注
            </Checkbox>
          </div>
        </div>
        <ProList<any>
          className="gn"
          ghost={true}
          style={{ height: 'calc(100vh - 200px)', overflowY: 'scroll', overflowX: 'hidden' }}
          itemCardProps={{
            ghost: true,
            bodyStyle: { padding: 0, margin: 0 },
            style: {
              width: '100%',
              border: 0,
              // minHeight: 700
              // padding: 0, margin: 0
              boxShadow: '0px 4px 8px 0px rgba(0,79,178,0.15)',
            },
          }}
          // search={{
          //   labelWidth: proTableCommonOptions.searchLabelWidth,
          // }}
          // headerTitle={
          //   <>
          //     <div>
          //       {Object.keys(tabOptions).map((item, index) => {
          //         // eslint-disable-next-line react/jsx-key
          //         return (
          //           <Button
          //             style={{ marginRight: 12,border: 'none' }}
          //             // type={activeTabIndex === index ? 'primary' : 'default'}
          //             key={index}
          //             onClick={() => {
          //               setActiveTabIndex(index);
          //             }}
          //           >
          //             {Object.keys(alarmRulesEnums).includes(item)
          //               ? alarmRulesEnums[item].miniName
          //               : ''}
          //           {"("+tabOptions[item]+ ')'}
          //           </Button>
          //         );
          //       })}
          //     </div>
          //   </>
          // }
          cardProps={{
            bodyStyle: {
              padding: '0',
              borderRadius: 4,
            },
          }}
          pagination={{
            ...proTablePaginationOptions,
            total: total,
            current: currentPage,
            pageSize: currentPageSize,
            showSizeChanger: true,
            onChange: (page, pageSize) => {
              console.log(page, pageSize);
              setCurrentPage(page);
              setCurrentPageSize(pageSize);
            },
          }}
          locale={{
            emptyText: (
              <div
                style={{
                  paddingBlockStart: 20,
                }}
              >
                <NoData />
              </div>
            ),
          }}
          showActions="hover"
          rowSelection={false}
          grid={{ gutter: 16, xs: 1, md: 2, lg: 2, xl: 5, xxl: 6 }}
          metas={{
            type: {
              // 不展示在筛选项
              hideInSearch: true,
            },
            content: {
              hideInSearch: true,
            },
            actions: {
              cardActionProps: 'extra',
            },
          }}
          dataSource={dataTestList}
        />
      </ProCard>

      {/* <CreateForm
        createModalOpen={createModalOpen}
        values={currentRow || {}}
        handleModal={handleCreateModal}
        reload={actionRef.current?.reload}
      /> */}
      <InvolvedDetails
        updateModalOpen={updateModalOpen}
        values={currentRow || {}}
        handleModal={handleUpdateModal}
        reload={initList}
      />
    </PageContainer>
  );
};

export default InvolvedList;
