/*
 * @Author: donghao donghao@supervision.ltd
 * @Date: 2024-04-01 19:20:30
 * @LastEditors: donghao donghao@supervision.ltd
 * @LastEditTime: 2024-04-02 17:44:55
 * @FilePath: \uighur-recognition-web2\src\services\realTime\interfaces.ts
 * @Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 */
// @ts-ignore
/* eslint-disable */
import { request } from '@umijs/max';

/** 接口列表 */
export async function getInterfaces(
  params: API.SearchAlarmRulesParams | any,
  options?: { [key: string]: any },
) {
  return request<API.Response & { data?: API.PageResult; msg?: string }>(`/api/device/`, {
    method: 'GET',
    headers: {
      'Content-Type': 'application/json',
    },
    params: {
      ...params,
    },
    ...(options || {}),
  });
}

/** 更新接口列表 */
export async function postInterfaces(
  body: API.UpdateInterfacesParams | any,
  options?: { [key: string]: any },
) {
  return request<API.Response & { data?: API.PageResult; msg?: string }>(`/api/device/`, {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
    },
    data: body,
    ...(options || {}),
  });
}
/** 测试接口 */
export async function postTestDevice(
  body: API.UpdateInterfacesParams | any,
  options?: { [key: string]: any },
) {
  return request<API.Response & { data?: API.PageResult; msg?: string }>(`/api/test_device/`, {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
    },
    data: body,
    ...(options || {}),
  });
}

/** 离线设备列表 */
export async function getInterfacesUpload(
  params: API.SearchAlarmRulesParams | any,
  options?: { [key: string]: any },
) {
  return request<API.Response & { data?: API.PageResult; msg?: string }>(`/api/upload_device/`, {
    method: 'GET',
    headers: {
      'Content-Type': 'application/json',
    },
    params: {
      ...params,
    },
    ...(options || {}),
  });
}

/** 更新接口列表 */
export async function postInterfacesUpload(
  body: API.UpdateInterfacesParams | any,
  options?: { [key: string]: any },
) {
  return request<API.Response & { data?: API.PageResult; msg?: string }>(`/api/upload_device/`, {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
    },
    data: body,
    ...(options || {}),
  });
}

/** 离线多线程 */
export async function getAlgorithm(
  params: API.SearchAlarmRulesParams | any,
  options?: { [key: string]: any },
) {
  return request<API.Response & { data?: API.PageResult; msg?: string }>(
    `/api/algorithm_configuration/`,
    {
      method: 'GET',
      headers: {
        'Content-Type': 'application/json',
      },
      params: {
        ...params,
      },
      ...(options || {}),
    },
  );
}

/** 离线多线程  */
export async function postAlgorithm(body: any, options?: { [key: string]: any }) {
  return request<API.Response & { data?: API.PageResult; msg?: string }>(
    `/api/algorithm_configuration/`,
    {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
      },
      data: body,
      ...(options || {}),
    },
  );
}

/** 获取平台信息及接口信息 */
export async function getPlatform(
  params: API.SearchAlarmRulesParams | any,
  options?: { [key: string]: any },
) {
  return request<API.Response & { data?: API.PageResult; msg?: string }>(`/api/platform/`, {
    method: 'GET',
    headers: {
      'Content-Type': 'application/json',
    },
    params: {
      ...params,
    },
    ...(options || {}),
  });
}

/** 更新平台信息及接口信息 */
export async function postPlatform(
  body: API.UpdateInterfacesParams | any,
  options?: { [key: string]: any },
) {
  return request<API.Response & { data?: API.PageResult; msg?: string }>(`/api/platform/`, {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
    },
    data: body,
    ...(options || {}),
  });
}

/** 测试平台连通 */
export async function postTestlPatform(
  body: API.UpdateInterfacesParams | any,
  options?: { [key: string]: any },
) {
  return request<API.Response & { data?: API.PageResult; msg?: string }>(`/api/test_platform/`, {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
    },
    data: body,
    ...(options || {}),
  });
}
