declare namespace API {
  type ActionDetection = {
    id?: string;
    source?: string;
    configFile?: string;
    type?: string;
    remark?: string;
    time?: number;
    imagesPath?: string;
  };

  type PageResult = {
    list?: any;
    page?: number;
    pageSize?: number;
    total?: number;
  };

  type AlarmListResponse = {
    code?: number;
    data?: any;
    msg?: string;
    success?: boolean;
    // count?: number,
    // next?: any,
    // previous?: any,
    // results?:any
  };

  type SearchAlarmListParams = {
    warning_type?: string;
    /** 排序方式:升序false(默认)|降序true */
    desc?: boolean;
    /** 页码 */
    page?: number;
    /** 每页大小 */
    pageSize?: number;
  };
  type SearchAlarmRulesParams = {
    id?: string;
  };
  type InterfacesForm = {
    code?: string;
    createTime?: string;
    id?: number;
    is_use?: number;
    device_name?: string;
    remark?: string;
    device_api?: string;
  };
  type UpdateAlarmRulesForm = {
    warning_name?: string; // 告警规则名称
    warning_type?: string; // 告警类型
    is_use?: number; // 是否启用
    person_number?: number; // 人数
    appear_number?: number; // 出现次数
    time_interval?: string; // 时间间隔(小时)
    time_period?: string; // 时间段(小时)
    trigger_start_time?: string; // 敏感起始时间
    trigger_end_time?: string; // 敏感结束时间
    id?: number;
  };
  type UpdateAlarmRulesParams = {
    warning_name?: string; // 告警规则名称
    warning_type?: string; // 告警类型
    is_use?: number; // 是否启用
    person_number?: number; // 人数
    appear_number?: number; // 出现次数
    time_interval?: string; // 时间间隔(小时)
    time_period?: string; // 时间段(小时)
    trigger_start_time?: string; // 敏感起始时间
    trigger_end_time?: string; // 敏感结束时间
    id?: string;
  };
  type UpdateInterfacesParams = {
    device_name?: string; // 设备名称
    device_code?: string; // 设备代码
    is_use?: number; // 是否启用
    device_api?: string; // 设备地址
    device_ip?: string; // IP地址
    note?: string; // 备注
    device_status?: string; // 设备状态
    id?: string;
    appear_time?: string; // 设备状态
    picture_path?: string;
    device_address?: string;
    device_port?: string;
    device_username?: string;
    device_password?: string;
    destination_directory?: string;
    operate_mode?: string;
    source_directory?: string;
    platform_name?: string;
  };
  type UpdateVideoParams = {
    create_time?: string; // 设备名称
    device_id?: string; // 设备代码
    id?: number; // 是否启用
    is_damaged?: number; // 是否启用
    is_finished?: number; // 是否启用
    is_warning_statistic?: number; // 是否启用
    status?: number; // 是否启用
    start_time?: string; // 设备地址
    update_time?: string; // IP地址
    upload_time?: string; // 备注
    video_length?: string; // 设备状态
    video_name?: string; // 设备状态
    video_path?: string;
    video_type?: string;
    video_status?: number;
  };
  type AlarmDetailsParams = {
    warning_name?: string; // 设备名称
    picture_path?: any; // 设备代码
    device_name?: string; // 是否启用
    person_id?: string;
    trigger_time?: string;
    person_list?: any;
    person_classify?: any;
    warning_type?: any;
    origin?: any;
    person_id_list?: any;
    id?: any;
    device_address?: any;
    video_start?: any;
    video_length?: any;
  };
  type IgnoringventsParams = {
    is_ignore?: any; // 设备代码        // 是否启用
    person_id?: string;
  };
  type UploadIgnoringventsParams = {
    is_ignore?: any; // 设备代码        // 是否启用
    id?: string;
  };
  type SearchInvolvedParams = {
    /** 人员标识 0为正常，1为重点关注，2为白名单 */
    classify?: string;
    /** 排序方式:升序false(默认)|降序true */
    desc?: boolean;
    /** 页码 */
    page?: number;
    /** 每页大小 */
    pageSize?: number;
  };
  type InvolvedDetailsParams = {
    /** 人员标识 0为正常，1为重点关注，2为白名单 */
    classify?: string;
    /** 人员id */
    person_id?: string;
    /** 人员照片 */
    picture_path?: string;
    /** 标记时间 */
    classify_time?: string;
    /** 设备id */
    device_id?: string;
    /** 设备名 */
    device_name?: string;
    /** 出现时间 */
    appear_time?: string;
  };
  type SearchInvolvedTravelParams = {
    /** 人员ID */
    person_id?: string;
    /** 排序方式:升序false(默认)|降序true */
    desc?: boolean;
    /** 页码 */
    page?: number;
    /** 每页大小 */
    pageSize?: number;
  };
  type RecognitionParams = {
    /** 人员ID */
    person_id?: string;
    /** 人员标识 0为正常，1为重点关注，2为白名单 */
    classify?: string;
  };
  type RecognitionParams = {
    /** 人员ID */
    id?: string;
    /** 时间 */
    start_time?: string;
  };
  type SearchInvolvedLastSevenDays = {
    /** 人员ID */
    person_id?: string;
  };
}
