/*
 * @Author: donghao donghao@supervision.ltd
 * @Date: 2024-03-29 17:42:08
 * @LastEditors: donghao donghao@supervision.ltd
 * @LastEditTime: 2024-04-01 14:52:43
 * @FilePath: \general\general-ai-manage\src\utils\FixMenuItemIcon.tsx
 * @Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 */
/**
 * @FixMenuItemIcon 菜单图标手动导入
 *
 *
 */
import {
  AreaChartOutlined,
  BellOutlined,
  BlockOutlined,
  BugOutlined,
  CalendarOutlined,
  CarOutlined,
  ContactsOutlined,
  DatabaseOutlined,
  DesktopOutlined,
  DollarCircleOutlined,
  DotChartOutlined,
  ExperimentOutlined,
  GatewayOutlined,
  HomeOutlined,
  PictureOutlined,
  SettingOutlined,
  ShopOutlined,
  StarFilled,
  TableOutlined,
  TeamOutlined,
  ThunderboltOutlined,
  UserOutlined,
  UserSwitchOutlined,
  WarningOutlined,
} from '@ant-design/icons';
import { MenuDataItem } from '@ant-design/pro-layout';
import { ReactComponent as OffLine } from '../../public/images/icons/off_line.svg';
import { ReactComponent as RealTime } from '../../public/images/icons/real_time.svg';
/** 告警列表 */
import { ReactComponent as AlarmList } from '../../public/images/icons/alarmList.svg';
/** 设备管理 */
import { ReactComponent as DeviceManagement } from '../../public/images/icons/deviceManagement.svg';
/** 规则设置 */
import { ReactComponent as RuleSetting } from '../../public/images/icons/ruleSetting.svg';
/** 识别分类 */
import { ReactComponent as Recognition } from '../../public/images/icons/recognition.svg';
/** 记录汇总 */
import { ReactComponent as RecordSummary } from '../../public/images/icons/recordSummary.svg';
/** 视频源管理 */
import { ReactComponent as VideoSourceManagement } from '../../public/images/icons/videoSourceManagement.svg';

const iconMap: any = {
  CarOutlined: <CarOutlined />,
  UserOutlined: <UserOutlined />,
  TableOutlined: <TableOutlined />,
  DollarCircleOutlined: <DollarCircleOutlined />,
  ShopOutlined: <ShopOutlined />,
  UserSwitchOutlined: <UserSwitchOutlined />,
  HomeOutlined: <HomeOutlined />,
  SettingOutlined: <SettingOutlined />,
  TeamOutlined: <TeamOutlined />,
  DotChartOutlined: <DotChartOutlined />,
  BlockOutlined: <BlockOutlined />,
  DesktopOutlined: <DesktopOutlined />,
  DatabaseOutlined: <DatabaseOutlined />,
  WarningOutlined: <WarningOutlined />,
  CalendarOutlined: <CalendarOutlined />,
  ExperimentOutlined: <ExperimentOutlined />,
  ThunderboltOutlined: <ThunderboltOutlined />,
  BugOutlined: <BugOutlined />,
  AreaChartOutlined: <AreaChartOutlined />,
  ContactsOutlined: <ContactsOutlined />,
  GatewayOutlined: <GatewayOutlined />,
  BellOutlined: <BellOutlined />,
  PictureOutlined: <PictureOutlined />,
  StarFilled: <StarFilled />,
  RealTime: <RealTime />,
  OffLine: <OffLine />,
  AlarmList: <AlarmList />,
  DeviceManagement: <DeviceManagement />,
  RuleSetting: <RuleSetting />,
  Recognition: <Recognition />,
  RecordSummary: <RecordSummary />,
  VideoSourceManagement: <VideoSourceManagement />,
};
// FIX从接口获取菜单时icon为string类型
const fixMenuItemIcon = (menus: MenuDataItem[]): MenuDataItem[] => {
  menus.forEach((item) => {
    const { icon, children } = item;
    if (typeof icon === 'string') {
      console.log(22, icon);
      if (icon in iconMap) {
        item.icon = iconMap[icon];
      } else {
        item.icon = '';
      }
      // let fixIconName = icon.slice(0, 1).toLocaleUpperCase() + icon.slice(1) + iconType;
      // // @ts-ignore
      // item.icon = React.createElement(allIcons[fixIconName] || allIcons[icon]);
    }
    // eslint-disable-next-line @typescript-eslint/no-unused-expressions
    children && children.length > 0 ? (item.children = fixMenuItemIcon(children)) : null;
  });
  return menus;
};

export default fixMenuItemIcon;
